| CMSIS-DSP Verison 1.1.0 CMSIS DSP Software Library

- CMSIS
- CORE
- DSP
- RTOS API
- SVD

- Main Page
- Reference

Functions
Square Root
Fast Math Functions

## Functions
arm_status | arm_sqrt_q15 (q15_t in, q15_t *pOut)
| Q15 square root function.
arm_status | arm_sqrt_q31 (q31_t in, q31_t *pOut)
| Q31 square root function.
__STATIC_INLINE arm_status | arm_sqrt_f32 (float32_t in, float32_t *pOut)
| Floating-point square root function.

## Description

Computes the square root of a number. There are separate functions for Q15, Q31, and floating-point data types. The square root function is computed using the Newton-Raphson algorithm. This is an iterative algorithm of the form:

          x1 = x0 - f(x0)/f'(x0)

where `x1` is the current estimate, `x0` is the previous estimate and `f'(x0)` is the derivative of `f()` evaluated at `x0`. For the square root function, the algorithm reduces to:

         x0 = in/2                         [initial guess]
         x1 = 1/2 * ( x0 + in / x0)        [each iteration]

## Function Documentation

__STATIC_INLINE arm_status arm_sqrt_f32 | ( | float32_t | in,
|  | float32_t * | pOut
| ) |  |

Parameters:

  [in] | in | input value.
  [out] | *pOut | square root of input value.

Returns:
  The function returns ARM_MATH_SUCCESS if input value is positive value or ARM_MATH_ARGUMENT_ERROR if `in` is negative value and returns zero output for negative values.

References ARM_MATH_ARGUMENT_ERROR, and ARM_MATH_SUCCESS.

Referenced by arm_cmplx_mag_f32(), arm_rms_f32(), and arm_std_f32().

arm_status arm_sqrt_q15 | ( | q15_t | in,
|  | q15_t * | pOut
| ) |  |

Parameters:

  [in] | in | input value. The range of the input value is [0 +1) or 0x0000 to 0x7FFF.
  [out] | *pOut | square root of input value.

Returns:
  The function returns ARM_MATH_SUCCESS if input value is positive value or ARM_MATH_ARGUMENT_ERROR if `in` is negative value and returns zero output for negative values.

References ARM_MATH_ARGUMENT_ERROR, and ARM_MATH_SUCCESS.

Referenced by arm_cmplx_mag_q15(), arm_rms_q15(), and arm_std_q15().

arm_status arm_sqrt_q31 | ( | q31_t | in,
|  | q31_t * | pOut
| ) |  |

Parameters:

  [in] | in | input value. The range of the input value is [0 +1) or 0x00000000 to 0x7FFFFFFF.
  [out] | *pOut | square root of input value.

Returns:
  The function returns ARM_MATH_SUCCESS if input value is positive value or ARM_MATH_ARGUMENT_ERROR if `in` is negative value and returns zero output for negative values.

References ARM_MATH_ARGUMENT_ERROR, and ARM_MATH_SUCCESS.

Referenced by arm_cmplx_mag_q31(), arm_rms_q31(), and arm_std_q31().